*     File chansc.f : Sat Nov  7 16:10:26 1998
*
*     Generated by GRACE (Fortran source code generator)
*         Ver.2.1.6(0) 1998/08/15
*
*     (c)copyright 1990-1998 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
*
C
C      ************************************************************
C      *                                                          *
C      *                                                          *
C      *                                                          *
C      *                                                          *
C      *                                                          *
C      *                                                          *
C      *             ============================                 *
C      *                CHANEL   (version. 2.X)                   *
C      *             ============================                 *
C      *                                                          *
C      *                                                          *
C      *             SUBROUTINES for SUSY processes.              *
C      *             Version. 2 should be added.                  *
C      *                                                          *
C      *                   Written by H. Tanaka                   *
C      *                                                          *
C      *                                                          *
C      *                        ---------                         *
C      *                        Reference                         *
C      *                        ---------                         *
C      *    ' Numerical Calculation of Helicity Amplitudes        *
C      *      for Processes Involving Massive Fermions'           *
C      *                                                          *
C      *      H. Tanaka, Hiroshima University preprint            *
C      *         Comput. Phys. Commun. 58(1990) 153 - 168         *
C      *                                                          *
C      *                                                          *
C      *                         and                              *
C      *                                                          *
C      *    ' Numerical Calculation of Feynman Amplitudes         *
C      *      for Electroweak Theories and Application to         *
C      *      e(-) e(+) --> W(+) W(-) photon '                    *
C      *                                                          *
C      *                                                          *
C      *          H. Tanaka, T. Kanako and Y. Shimizu             *
C      *          KEK preprint 90 - 29, May 1990.                 *
C      *                                                          *
C      *                                                          *
C      *       New version according to T.Kaneko                  *
C      *                                                          *
C      *   --- TEST VERSION OF CHANSC ---                         *
C      ************************************************************
C********************************************************************
C *         S                                                        *
C *         |                                                        *
C *         |                                                        *
C * F1--<---|---<---F2    SUBROUTINE FFSNNN(FFS)                     *
C *                                                                  *
C *     Purpose: to calculate vertex amplitudes for scalar boson-    *
C *              massive fermions vertex.                            *
C *                                                                  *
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *
C *            (I,II=1) state.                                       *
C *     AM,AAM=: masses of fermions.                                 *
C *     AL,AR=: coupling constants for vertex.                       *
C *     C,CC=: phase factors for massive fermions.                   *
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *
C *                   SPLTQ.                                         *
C *     AALL=: calculated results of vertex amplitudes for all       *
C *            possible helicity states.                             *
C *                                                                  *
C *                                                                  *
C *                                      written by H. Tanaka        *
C ********************************************************************
C

C       ===========================================================
        SUBROUTINE FFSNNN(II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)
C       ===========================================================
C
         IMPLICIT REAL*8(A-H,O-Z)
         COMPLEX*16 AALL
         COMPLEX*16 C,CC,AALL11,AALL22,AALL12,AALL21
         DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2)
         DIMENSION AALL(2,2),AALL11(2),AALL22(2),AALL12(2),AALL21(2)
         CALL FFS0(Q1,P1,AALL11)
         CALL FFS0(Q2,P2,AALL22)
         CALL FFS0(Q1,P2,AALL12)
         CALL FFS0(Q2,P1,AALL21)

         R  = DFLOAT(I  - 2)
         RR = DFLOAT(II - 2)

         IF (AM.LE.0.0D0) THEN
         R = 0.0D0
         ENDIF
         IF (AAM.LE.0.0D0) THEN
         RR = 0.0D0
         ENDIF

         J1 = (5-II)/2
         J2 = 3 - J1
         K1 = (5-I)/2
         K2 = 3 - K1

         AALL(J1,K2)=(AR*AALL11(1))
     &               +(AL*R*RR*C(1)*CC(2)*AALL22(2))
         AALL(J2,K1)=(AL*AALL11(2))
     &               +(AR*R*RR*C(2)*CC(1)*AALL22(1))
         AALL(J2,K2)=-(AR*RR*CC(1)*AALL21(1))
     &                -(AL*R*C(1)*AALL12(2))
         AALL(J1,K1)=-(AL*RR*CC(2)*AALL21(2))
     &                -(AR*R*C(2)*AALL12(1))
CX         AALL(J1,K2)=CC(1)*C(2)*AALL(J1,K2) 
CX         AALL(J2,K1)=CC(2)*C(1)*AALL(J2,K1)
CX         AALL(J2,K2)=CC(2)*C(2)*AALL(J2,K2)
CX         AALL(J1,K1)=CC(1)*C(1)*AALL(J1,K1)


         RETURN
         END
C                                                                              
C ********************************************************************         
C *         S                                                        *         
C *         !                                                        *         
C *         !                                                        *         
C * F1-->---!--->---F2    SUBROUTINE FFSCCC(-FFST)                   *         
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for scalar boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -          C             C         C                        *         
C *      U(II,AAM,Q) (AL*PL+AR*PR) U(I,AM,P)                         *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFSCCC(II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)              
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                             
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2)                           
        DIMENSION AALL(2,2)                                         
                                                                               
        I1 = I - 2                                                             
        I1 = -I1                                                               
        I1 = I1 + 2                                                            
                                                                               
        I2 = II - 2                                                            
        I2 = -I2                                                               
        I2 = I2 + 2                                                            
                                                                               
        CALL FFSNNN(I2,I1,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)                     
                                                                               
                                                                               
        RETURN                                                                 
        END                                                                    
C                                                                              
C ********************************************************************         
C *         S                                                        *         
C *         !                                                        *         
C *         !                                                        *         
C * F1-->---!---<---F2    SUBROUTINE FFSCCN(-FFSCT)                  *         
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for scalar boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -          C             C                                  *         
C *      U(II,AAM,Q) (AL*PL+AR*PR)  U(I,AM,P)                        *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFSCCN(II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)              
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                             
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2)                           
        DIMENSION AALL(2,2)                                         
                                                                               
        I2 = II - 2                                                            
        I2 = -I2                                                               
        I2 = I2 + 2                                                            
                                                                               
        CALL FFSNNN(I2,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)                      
                                                                               
                                                                               
        RETURN                                                                 
        END                                                                    
C                                                                              
C ********************************************************************         
C *         S                                                        *         
C *         !                                                        *         
C *         !                                                        *         
C * F1--<---!--->---F2    SUBROUTINE FFSNCC(-FFCST)                  *         
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for scalar boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -                        C          C                       *         
C *      U(II,AAM,Q) (AL*PL+AR*PR)  U(I,AM,P)                        *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFSNCC(II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)              
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                             
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2)                           
        DIMENSION AALL(2,2)                                          
                                                                               
        I1 = I - 2                                                             
        I1 = -I1                                                               
        I1 = I1 + 2                                                            
                                                                               
        CALL FFSNNN(II,I1,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)                     
                                                                               
                                                                               
        RETURN                                                                 
        END  
C ********************************************************************         
C *         S                                                        *         
C *         !                                                        *         
C *         !                                                        *         
C * F1--<---!---<---F2    SUBROUTINE FFSNCN(FFCSCT)                  *         
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for scalar boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -                        C                                  *         
C *      U(II,AAM,Q) (AL*PL+AR*PR)  U(I,AM,P)                        *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFSNCN(II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)             
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                            
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2)                           
        DIMENSION AALL(2,2)                                          
                                                                               
        CALL FFSNNN(II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)                      
                                                                               
        RETURN                                                                 
        END                                                                    
C ********************************************************************         
C *         S                                                        *         
C *         !                                                        *         
C *         !                                                        *         
C * F1-->---!--->---F2    SUBROUTINE FFCNC(-FFCSC)                   *         
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for scalar boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -          C                       C                        *         
C *      U(II,AAM,Q) (AL*PL+AR*PR) U(I,AM,P)                         *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFSCNC(II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)             
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                            
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2)                           
        DIMENSION AALL(2,2)                                          
                                                                               
        I1 = I - 2                                                             
        I1 = -I1                                                               
        I1 = I1 + 2                                                            
                                                                               
        I2 = II - 2                                                            
        I2 = -I2                                                               
        I2 = I2 + 2                                                            
                                                                               
        CALL FFSNNN(I2,I1,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)                     

                                                                               
        RETURN                                                                 
        END                                                                    
C ********************************************************************         
C *            S                                                     *      
C *            !                                                     *      
C *            !                                                     *      
C *  F1---->---!---<--- F2    SUBROUTINE FFSCNN(FFCS)                *     
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for scalar boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -          C                                                *         
C *      U(II,AAM,Q)  (AL*PL+AR*PR) U(I,AM,P)                        *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFSCNN(II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)              
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                             
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2)                           
        DIMENSION AALL(2,2)                                         
                                                                               
        I2 = II - 2                                                            
        I2 = -I2                                                               
        I2 = I2 + 2                                                            
                                                                               
        CALL FFSNNN(I2,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)                      
                                                                               
        RETURN                                                                 
        END                                                                    
C                                                                              
C ********************************************************************         
C *         S                                                        *         
C *         !                                                        *         
C *         !                                                        *         
C * F1--<---!--->---F2    SUBROUTINE FFSNNC(FFSC)                    *         
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for scalar boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -                                  C                        *         
C *      U(II,AAM,Q) (AL*PL+AR*PR) U(I,AM,P)                         *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFSNNC(II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)              
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                             
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2)                           
        DIMENSION AALL(2,2)                                         
                                                                               
        I1 = I - 2                                                             
        I1 = -I1                                                               
        I1 = I1 + 2                                                            
                                                                               
        CALL FFSNNN(II,I1,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,AALL)                     
                                                                               
        RETURN                                                                 
        END  

C                                                                              
C ********************************************************************         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *   SUBROUTINE FFV(L:I*4, II:I*4, I:I*4, AAM:R*8, AM:R*8,          *         
C *  &               AL:R*8, AR:R*8, CC:C*16(2), C:C*16(2),          *         
C *  &               Q1:R*8(4), Q2:R*8(4), P1:R*8(4), P2:R*8(4),     *         
C *  &               Q:R*8(4), AALL:C*16(4,2,2))                     *         
C *                                                                  *         
C *     Purpose: To calculate vertex amplitudes for vector boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *     L=: Polarization state of vector boson.                      *         
C *     I,II=: Indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: Masses of fermions.                                 *         
C *     AL,AR=: Coupling constants for vertex.                       *         
C *     C,CC=: Phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: Light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     Q=: Polarization vector of vector boson.                     *         
C *     AALL=: Calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C *                                                                  *         
C *    Q1, Q2 : FOR UB OR VB                                         *         
C *    P1, P2 : FOR U OR V                                           *         
C *                                                                  *         
C *                                                                  *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFVNNN(L,II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,Q,AALL)         
C       ===========================================================            
C                                                                              
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL                                                        
        COMPLEX*16 C,CC,AALL11,AALL22,AALL12,AALL21                            
        DIMENSION Q(4),P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2)                      
        DIMENSION AALL(4,2,2),AALL11(2),AALL22(2),AALL12(2),AALL21(2)          
                                                                               
        CALL FFV0(Q1,P1,Q,AALL11)                                              
        CALL FFV0(Q2,P2,Q,AALL22)                                              
        CALL FFV0(Q1,P2,Q,AALL12)                                              
        CALL FFV0(Q2,P1,Q,AALL21)                                              
        R  = DFLOAT(I  - 2)                                                    
        RR = DFLOAT(II - 2)                                                    
        IF (AM.LE.0.0D0) THEN                                                  
          R = 0.0D0                                                            
        ENDIF                                                                  
        IF (AAM.LE.0.0D0) THEN                                                 
          RR = 0.0D0                                                           
        ENDIF                                                                  
                                                                               
        J1 = (5-II)/2                                                          
        J2 = 3 - J1                                                            
        K1 = (5-I)/2                                                           
        K2 = 3 - K1                                                            
                                                                               
        AALL(L,J1,K1)=(AL*AALL11(1))                                           
     &               +(AR*R*RR*C(2)*CC(2)*AALL22(2))                           
        AALL(L,J2,K2)=(AR*AALL11(2))                                           
     &               +(AL*R*RR*C(1)*CC(1)*AALL22(1))                           
        AALL(L,J1,K2)=-(AR*RR*CC(2)*AALL21(2))                                 
     &                -(AL*R*C(1)*AALL12(1))                                   
        AALL(L,J2,K1)=-(AL*RR*CC(1)*AALL21(1))                                 
     &                -(AR*R*C(2)*AALL12(2))                                   
                                                                               
CX     AALL(L,J1,K1)=CC(1)*C(1)*AALL(L,J1,K1)  
CX     AALL(L,J2,K2)=CC(2)*C(2)*AALL(L,J2,K2) 
CX     AALL(L,J1,K2)=CC(1)*C(2)*AALL(L,J1,K2)   
CX     AALL(L,J2,K1)=CC(2)*C(1)*AALL(L,J2,K1)    

        RETURN                                                                 
        END                                                                    
C ********************************************************************         
C *         V                                                        *         
C *         !                                                        *         
C *         !                                                        *         
C * F1-->---!--->---F2    SUBROUTINE FFVCCC(-FFVT)                   *
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for vector boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -          C                C         C                     *         
C *      U(II,AAM,Q) (Q(AL*PL+AR*PR)) U(I,AM,P)                      *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     L=: polarization state of vector boson.                      *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     Q=: polarization vector of vector boson.                     *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFVCCC(L,II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,Q,AALL)
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                                   
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2),Q(4)                      
        DIMENSION AALL(4,2,2)                                                  
                                                                               
                                                                               
        I1 = I - 2                                                             
        I1 = -I1                                                               
        I1 = I1 + 2                                                            
                                                                               
        I2 = II - 2                                                            
        I2 = -I2                                                               
        I2 = I2 + 2                                                            
                                                                               
        CALL FFV(L,I2,I1,AAM,AM,AR,AL,CC,C,Q1,Q2,P1,P2,Q,AALL)                 

        AALL(L,1,1)=-AALL(L,1,1)  
        AALL(L,1,2)=-AALL(L,1,2)
        AALL(L,2,1)=-AALL(L,2,1)  
        AALL(L,2,2)=-AALL(L,2,2)

        RETURN                                                                 
        END                                                                    
C                                                                              
C ********************************************************************         
C *         V                                                        *         
C *         !                                                        *         
C *         !                                                        *         
C * F1-->---!---<---F2    SUBROUTINE FFVCCN(-FFVCT)                  *         
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for vector boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -          C                C                               *         
C *      U(II,AAM,Q) (Q(AL*PL+AR*PR))  U(I,AM,P)                     *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     L=: polarization state of vector boson.                      *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     Q=: polarization vector of vector boson.                     *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFVCCN(L,II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,Q,AALL)          
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                                   
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2),Q(4)                      
        DIMENSION AALL(4,2,2)                                                  
                                                                               
        I2 = II - 2                                                            
        I2 = -I2                                                               
        I2 = I2 + 2                                                            
                                                                               
        CALL FFV(L,I2,I,AAM,AM,AR,AL,CC,C,Q1,Q2,P1,P2,Q,AALL)                  


        AALL(L,1,1)=-AALL(L,1,1)
        AALL(L,1,2)=-AALL(L,1,2)
        AALL(L,2,1)=-AALL(L,2,1)
        AALL(L,2,2)=-AALL(L,2,2)  


        RETURN                                                                 
        END                                                                    
C                                                                              
C ********************************************************************         
C *         V                                                        *         
C *         !                                                        *         
C *         !                                                        *         
C * F1--<---!--->---F2    SUBROUTINE FFVNCC(-FFCVT)                  *         
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for vector boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -                           C          C                    *         
C *      U(II,AAM,Q) (Q(AL*PL+AR*PR))  U(I,AM,P)                     *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     L=: polarization state of vector boson.                      *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     Q=: polarization vector of vector boson.                     *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFVNCC(L,II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,Q,AALL)          
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                                   
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2),Q(4)                      
        DIMENSION AALL(4,2,2)                                                  
                                                                               
        I1 = I - 2                                                             
        I1 = -I1                                                               
        I1 = I1 + 2                                                            
                                                                               
        CALL FFV(L,II,I1,AAM,AM,AR,AL,CC,C,Q1,Q2,P1,P2,Q,AALL)                 

        AALL(L,1,1)=-AALL(L,1,1)
        AALL(L,1,2)=-AALL(L,1,2)
        AALL(L,2,1)=-AALL(L,2,1)
        AALL(L,2,2)=-AALL(L,2,2)  



        RETURN                                                                 
        END 
                                                                            
C ********************************************************************         
C *         V                                                        *         
C *         !                                                        *         
C *         !                                                        *         
C * F1--<---!---<---F2    SUBROUTINE FFVNCN(FFCVCT)                  *         
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for vector boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -                           C                               *         
C *      U(II,AAM,Q) (Q(AL*PL+AR*PR)) U(I,AM,P)                      *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     L=: polarization state of vector boson.                      *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     Q=: polarization vector of vector boson.                     *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFVNCN(L,II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,Q,AALL)         
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                                   
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2),Q(4)                      
        DIMENSION AALL(4,2,2)                                                  
                                                                               
        CALL FFV(L,II,I,AAM,AM,AR,AL,CC,C,Q1,Q2,P1,P2,Q,AALL)
                  
        AALL(L,1,1) = -AALL(L,1,1)                                            
        AALL(L,1,2) = -AALL(L,1,2)                                            
        AALL(L,2,1) = -AALL(L,2,1)                                            
        AALL(L,2,2) = -AALL(L,2,2)                                            
                                                                               
        RETURN                                                                 
        END                                                                    
C ********************************************************************         
C *         V                                                        *         
C *         !                                                        *         
C *         !                                                        *         
C * F1-->---!--->---F2    SUBROUTINE FFVCNC(-FFCVC)                  *         
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for vector boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -          C                          C                     *         
C *      U(II,AAM,Q) (Q(AL*PL+AR*PR)) U(I,AM,P)                      *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     L=: polarization state of vector boson.                      *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     Q=: polarization vector of vector boson.                     *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFVCNC(L,II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,Q,AALL)         
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                                   
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2),Q(4)                      
        DIMENSION AALL(4,2,2)       
                                           
        I1 = I - 2                                                             
        I1 = -I1                                                               
        I1 = I1 + 2                                                            
                                                                               
        I2 = II - 2                                                            
        I2 = -I2                                                               
        I2 = I2 + 2                                                            
                                                                               
                                                                               
        CALL FFV(L,I2,I1,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,Q,AALL)
                  
                                                                               
        RETURN                                                                 
        END                                                                    
C                                                                              
C ********************************************************************         
C *         V                                                        *         
C *         !                                                        *         
C *         !                                                        *         
C * F1-->---!---<---F2    SUBROUTINE FFVCNN(FFCV)                    *         
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for vector boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -          C                                                *         
C *      U(II,AAM,Q) (Q(AL*PL+AR*PR)) U(I,AM,P)                      *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     L=: polarization state of vector boson.                      *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     Q=: polarization vector of vector boson.                     *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFVCNN(L,II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,Q,AALL)           
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                                   
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2),Q(4)                      
        DIMENSION AALL(4,2,2)                                                  
                                                                               
        I2 = II - 2                                                            
        I2 = -I2                                                               
        I2 = I2 + 2                                                            
                                                                               
        CALL FFV(L,I2,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,Q,AALL)                  
                                                                               
        RETURN                                                                 
        END                                                                    
C                                                                              
C ********************************************************************         
C *         V                                                        *         
C *         !                                                        *         
C *         !                                                        *         
C * F1--<---!--->---F2    SUBROUTINE FFVNNC(FFVC)                    *         
C *                                                                  *         
C *     Purpose: to calculate vertex amplitudes for vector boson-    *         
C *              massive fermions vertex.                            *         
C *                                                                  *         
C *      -                                     C                     *         
C *      U(II,AAM,Q) (Q(AL*PL+AR*PR)) U(I,AM,P)                      *         
C *                                                                  *         
C *                                                                  *         
C *                                                                  *         
C *     L=: polarization state of vector boson.                      *         
C *     I,II=: indices to specify fermion(I,II=3) or antifermion     *         
C *            (I,II=1) state.                                       *         
C *     AM,AAM=: masses of fermions.                                 *         
C *     AL,AR=: coupling constants for vertex.                       *         
C *     C,CC=: phase factors for massive fermions.                   *         
C *     P1,P2,Q1,Q2=: light-like vectors decomposed by subroutine    *         
C *                   SPLTQ.                                         *         
C *     Q=: polarization vector of vector boson.                     *         
C *     AALL=: calculated results of vertex amplitudes for all       *         
C *            possible helicity states.                             *         
C *                                                                  *         
C *                                                                  *         
C *                                      written by H. Tanaka        *         
C ********************************************************************         
C                                                                              
C                                                                              
C       ===========================================================            
        SUBROUTINE FFVNNC(L,II,I,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,Q,AALL)           
C       ===========================================================            
C                                                                              
        IMPLICIT REAL*8(A-H,O-Z)                                               
        COMPLEX*16 AALL,C,CC                                                   
        DIMENSION P1(4),P2(4),Q1(4),Q2(4),C(2),CC(2),Q(4)                      
        DIMENSION AALL(4,2,2)                                                  
                                                                               
        I1 = I - 2                                                             
        I1 = -I1                                                               
        I1 = I1 + 2

        CALL FFV(L,II,I1,AAM,AM,AL,AR,CC,C,Q1,Q2,P1,P2,Q,AALL)

        RETURN
        END
