*     File kinit.f : Fri Apr 24 23:08:47 1998
*
*     Generated by GRACE (Fortran source code generator)
*         Ver.2.1.5(0) 1998/01/23
*
*     (c)copyright 1990-1996 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
*
      SUBROUTINE KINIT(lu)
      IMPLICIT REAL*8(A-H,O-Z)
C---------------------------------------------------------------------
C   GRACE System Library File
C   KINEM No. : 2001
C   Date      : 1994.04.30
C   Author    : Y.Kurihara
C---------------------------------------------------------------------
 
      PARAMETER ( MXDIM = 50 )
      COMMON / LOOP0 / LOOP
      COMMON / BPARM1 / XL(MXDIM),XU(MXDIM),NDIM,NWILD,
     &                 IG(MXDIM),NCALL
      COMMON / BPARM2 / ACC1,ACC2,ITMX1,ITMX2
 
      CHARACTER XSTR*14
 
      INCLUDE  'inclk.h'
      common /amjprc/jproc
*-----------------------------------------------------------------------
      COMMON/KINEM1/S,W,FACT
      COMMON/KCNTL1/ICOST,Isf
      COMMON/CUT001/COSCUT(2)
      common / knmflg / knmgvs, knmhst, knmsph, knmisr
*-----------------------------------------------------------------------
* 2-body kinematics
*
*  Integration variables
*        COS(the),Phi
*
C ---------- Initialization parameters for PDFLIB ----------
      character*20      PARM(20)
      integer           NVALUE(20)
      double precision  VALUE(20)
 
      integer         IFLPRT
       common /W50510/IFLPRT
 
      double precision   xmin,xmax, Q2min,Q2max
       common /W50513/   xmin,xmax, Q2min,Q2max
 
      real*8       P1_lab,P2_lab,E1_lab,E2_lab
     &            ,Pcms_lab,Ecms_lab, GAMMAcms_lab,BETGAMcms_lab
       common /LAB/P1_lab,P2_lab,E1_lab,E2_lab
     &            ,Pcms_lab,Ecms_lab, GAMMAcms_lab,BETGAMcms_lab
 
      real*8   amp
 
C ----------------------------------------------------------
      if(jproc.ne.1) then
*----- BASES RELATED INITIALIZATIONS -----------------------------------
*--- 3. Dimension of integration variables.

          NDIM =   5
          NWILD=   5

*--- 5. Number of iterations
      ITMX1  =  5
      ITMX2  =  5

      NCALL  = 5000
*--- 6. Set MXREG : the maximum number of values which are returned
*       by FUNC for one phase space point

      MXREG =   1
      else

*--- 1. Initialize constants for kinematics.
 
      amp = 0.93827231D0  !!!!!! Mass of proton !!!
      P1_lab = 820.       !!!!!! Proton   energy in the initial state
      P2_lab =  27.5      !!!!!! Electron energy in the initial state
       E1_lab = sqrt(P1_lab**2+amp**2)
       E2_lab = sqrt(P2_lab**2+AMASS2(2))
      S = AMASS2(1)+AMASS2(2) + 2.D0*(E1_lab*E2_lab + P1_lab*P2_lab)
       W = sqrt( max(0.D0,S) )        ! Electrons enter
      Pcms_lab = P1_lab - P2_lab      !    in the negative direction
      Ecms_lab = E1_lab + E2_lab      !       of z-axis
       GAMMAcms_lab = Ecms_lab/W
       BETGAMcms_lab  = Pcms_lab/W
 
*
* Isf=1: use PDF lib
*    =0: fixed energy
*
      Isf=1
      if(Isf.eq.0) then
       w=240.d0
       s=w*w
      end if
      write(lu,*) '********** Information (in Lab. frame) **********'
      write(lu,*) '                              (in unit of GeV)'
      write(lu,'(A23,G9.3)') '  Mass of proton    =',real(amp)
      write(lu,'(A23,G9.3)') '  sqrt(S)           =',real(W)
      write(lu,'(A23,G9.3)') '  P of CMS          =',real(Pcms_lab)
      write(lu,'(A23,G9.3)') '  E of CMS          =',real(Ecms_lab)
      write(lu,'(A23,G9.3)') '  gamma of CMS      =',real(GAMMAcms_lab)
      write(lu,'(A23,G9.3)') '  beta*gamma of CMS =',real(BETGAMcms_lab)
      write(lu,*) 'Structure Function on/off ',Isf
      write(lu,*) '***********************************************'
 
      Q2min = 0.D0          ! User default of Q2 limits
      Q2max = 1.D40         !    used in PDFLIB
C --------------- PDFLIB Initialization ---------------
      if(Isf.eq.1) then
      IFLPRT = 2         ! Printing the setting values of PDFLIB?
      PARM(1) = 'Nptype'
       VALUE(1) = 1      ! Particle type (1:Nucleon)
      PARM(2) = 'Ngroup'
       VALUE(2) = 3      ! Author group
      PARM(3) = 'Nset'
       VALUE(3) = 14      ! Structure function set
C      PARM(4) = 'XMIN'
C       VALUE(4) = 0.0001
C      PARM(5) = 'XMAX'
C       VALUE(5) = 1.
C      PARM(6) = 'Q2MIN'
C       VALUE(6) = 3.
C      PARM(7) = 'Q2MAX'
C       VALUE(7) = 100000.
C      PARM(7) = 'NFL'
C       VALUE(7) = 6
 
      call PDFSET(PARM, VALUE)
      call PDFSTA
      end if




* Energy and anluare cuts
* minimum cos  cut for particle 3
      COSCUT(1)= -1
* maximum cos  cut for particle 3
      COSCUT(2)=  1
*If  ICOST=+-1
* -t=(p1-p3)**2 is used as integration variable. 
*  +1; forward peak.
*  -1; forward and backward peaks.
      ICOST=0

c     WRITE(6,*)'*'
c     WRITE(6,*)'* Kinematics initialization '
c     WRITE(6,*)'* particle mass ',amass1
c     WRITE(6,*)'* CM Energy ',W
c     WRITE(6,*)'* COSCUT    '
c     WRITE(6,'(2F20.8)')COSCUT
c     WRITE(6,*)'* Integration Variable '
c     if(icost.eq.0) then
c     WRITE(6,*)'* cos3 '
c     else if(icost.eq.+1) then
c     WRITE(6,*)'* -t ;forward peak'
c     else if(icost.eq.-1) then
c     WRITE(6,*)'* -t ;forward-backward peak'
c     else
c     WRITE(6,*)'* icost should be 0 or +-1.',icost
c     end if
c     WRITE(6,*)'*'
 
* Following flux factor is for a particle-antiparticle collision
* at s/m**2 >> 1. For an e-gamma collision or low energy interactions
* you should use appropriate formulae.
      VREL = 2
      FLUX = VREL*S
      FACT = GEVPB/FLUX
 
*----- BASES RELATED INITIALIZATIONS -----------------------------------
*--- 3. Dimension of integration variables.
       if(Isf.eq.1) then
          NDIM =  13
          NWILD=  13
       else
          NDIM =  12
          NWILD=  12
       end if
 

C-----------------------------------------------------------------------
*--- 5. Number of iterations
      ITMX1  =  5
      ITMX2  =  10
 
      NCALL  = 40000
 
*--- 6. Set MXREG : the maximum number of values which are returned
*       by FUNC for one phase space point
 
      MXREG =   1
 
*--- 7. Set histograms
      if( knmhst .eq. 1 ) then
      NX = 50
      ND = 50
 

         CALL XHINIT( 1, 0.d0, w, NX, 'Energy of Particle 3')
         CALL XHINIT( 2, 0.d0, w, NX, 'Energy of Particle 4')
         CALL XHINIT( 3, 0.d0, w, NX, 'Energy of Particle 5')
         CALL XHINIT( 4, 0.d0, w, NX, 'Energy of Particle 6')
         CALL XHINIT( 5, 0.d0, w, NX, 'Energy of Particle 7')
         CALL XHINIT( 6, 0.d0, w, NX, 'Energy of Particle 8')
         CALL XHINIT( 7,-1.d0,1.d0, NX, 'cos_the of Particle 3')
         CALL XHINIT( 8,-1.d0,1.d0, NX, 'cos_the of Particle 4')
         CALL XHINIT( 9,-1.d0,1.d0, NX, 'cos_the of Particle 5')
         CALL XHINIT(10,-1.d0,1.d0, NX, 'cos_the of Particle 6')
         CALL XHINIT(11,-1.d0,1.d0, NX, 'cos_the of Particle 7')
         CALL XHINIT(12,-1.d0,1.d0, NX, 'cos_the of Particle 8')
         CALL XHINIT(13, 0.d0, w, NX, 'Mass 4-5 ')
         CALL XHINIT(14, 0.d0, w, NX, 'Mass 6-7 ')
         CALL XHINIT(15, 0.d0, w, NX, 'Mass 4-5-6-7-8')
         CALL XHINIT(16, 0.d0, w, NX, 'Mass 6-7-8')
         CALL XHINIT(17, 0.d0, w, NX, 'sqrt(s) ')
         CALL XHINIT(18, 0.d0, 100.d0, NX, 'pT(mu+) ')
         CALL XHINIT(19, 0.d0, 100.d0, NX, 'pT(e-) ')
         CALL XHINIT(20, 0.d0, 100.d0, NX, 'pT(nu-mu)=pT missing ')
         CALL XHINIT(21, 0.d0, 100.d0, NX, 'pT(jet)')

         CALL XHINIT(22, 0.d0, 100.d0, NX, 'pT(s)')
         CALL XHINIT(23, 0.d0, 100.d0, NX, 'pT(d)')
         CALL XHINIT(24, 0.d0, 100.d0, NX, 'pT(c)')

         CALL XHINIT(25,-1.d0,1.d0,NX,'cos*(mu)')
         CALL XHINIT(26,-1.d0,1.d0,NX,'cos(s-c)')



      endif
      endif
        do 1 i=1,ndim
         XL(i)  =   0.D0
         XU(i)  =   1.D0
         IG(i)  =   1
1       continue
      RETURN
      END
