*     File suneum.f : Mon Jun  1 15:34:18 1998
*
*     Generated by GRACE (Fortran source code generator)
*         Ver.2.1.5(1) 1998/03/18
*
*     (c)copyright 1990-1998 Minami-Tateya Group, Japan
*-----------------------------------------------------------------------
*
c *********************************************************
c **                                                     **
c **  Subroutine Neutralino Eigensystem                  **
c **                                                     **
c **  Notation ; "JLC supersymmetry manual" by K.Hikasa  **
c **                                                     **
c ** CREATED by T.KON                                    **
c ** REVISED by TI(970827) Using Householder Method      **
c ** Revised by TI(980222) Patched                       **
c **             (mssm215.fin)                           **
c *********************************************************

      subroutine suneum
c
      implicit real*8(a-h,o-z)
* work area
      dimension a(4,4),u(4,4),xx(4)
*     dimension  xmnz(4),xx(4)
*     complex*16  sgn(4)
c
*     common/amcnst/pi, pi2, rad, gevpb, alpha
*     common/smpr/alp,alps,sw2,xmz,xmw,pbgev
*     common/smm/ammu,amta,amcq,amsq,ambq,amtq
*     common/spara/xm2,xmu,tanbe,tht
*     common/neut/xmnz,on,sgn
      complex*16 etan
      common /suneut/ xmnl(4),ogmn(4,4),etan(4)
*-----------------------------------------------------------------------
      common /subkpm/ xm1,xm2,xm3,xmu
      common /suindp/ sw,cw,tw,sw2,
     &                tanbe,cb,sb,c2b,s2b
*-----------------------------------------------------------------------
      include 'inclm.h'
      dimension a0(4,4),bmtx(4,4),cmtx(4,4)
*-----------------------------------------------------------------------
      DIMENSION WORK(4,7),LW(4),E(4),V(4,4)
      DIMENSION IS(4),IR(4)
      dimension ogmn2(4,4)
*-----------------------------------------------------------------------

c
      f1=1.d0
      f2=1.d0
*     f3=1.d0
c
*     sw    = sqrt(sw2)                                               
*     cw2   = 1.d0-sw2                                            
*     cw    = sqrt(cw2)                                            
*     tw    = sw/cw                                                  
*     eu     = 2.d0/3.d0
*     ed     =-1.d0/3.d0
*     ee     =-1.d0
*     gwk  = sqrt(4.d0*pi*alp/sw2)
c
*     if(tanbe.ge.0.d0) then 
*        bt = atan(tanbe)
*     else
*        bt = atan(tanbe)+pi
*     end if
*     sb=dsin(bt)
*     cb=dcos(bt)
                                                                       
*     xmgl   = alps*sw2/alp*f3/f2*xm2 
      xm1    = (5.d0/3.d0)*xm2*tw**2*f1/f2

c
c**************************
c*                        *
c*       mass matrix      *
c*                        *
c*        ( n =4 )        *
c*                        *
c**************************
c
      n=4
      eps=1.0d-50
      eps=1.0d-100
c
      a0(1,1)=+xm1
      a0(1,2)=+0.0d0
      a0(1,3)=-amz*sw*cb
      a0(1,4)=+amz*sw*sb
      a0(2,1)=+0.0d0
      a0(2,2)=+xm2
      a0(2,3)=+amz*cw*cb
      a0(2,4)=-amz*cw*sb
      a0(3,1)=-amz*sw*cb
      a0(3,2)=+amz*cw*cb
      a0(3,3)=+0.0d0
      a0(3,4)=-xmu
      a0(4,1)=+amz*sw*sb
      a0(4,2)=-amz*cw*sb
      a0(4,3)=-xmu
      a0(4,4)=+0.0d0
c
      do 110 j=1,n
      do 110 i=1,n
         a(i,j)=a0(i,j)
         u(i,j)=0.0d0
         if(i.eq.j) u(i,j)=1.0d0
  110 continue
c
      k=0
  210 continue
      k=k+1
      xmax=0.0d0
c
      do 220 i=1,n-1
      do 220 j=i+1,n
         if( abs(a(i,j)).gt.xmax) then
             xmax = abs(a(i,j))
               ip = i
               iq = j
         endif
  220 continue
c
      if( xmax.le.eps) go to 270
c
           w1 = a(ip,ip)
           w2 = a(ip,iq)
           w3 = a(iq,iq)
          alf = -w2
          bet = 0.5d0*(w1-w3)
          gam = abs(bet)/sqrt(alf**2+bet**2)
            s = sqrt(0.5d0*(1.0d0-gam))

          if( alf*bet.lt.0.0d0) s = -s
            c = sqrt(1.0d0-s**2)
c
          do 240 j=1,n
                   w = a(ip,j)*c-a(iq,j)*s
             a(iq,j) = a(ip,j)*s+a(iq,j)*c
             a(ip,j) = w
  240     continue
c
          do 250 j=1,n
             a(j,ip) = a(ip,j)
             a(j,iq) = a(iq,j)
  250     continue
c
                 w = 2.0d0*w2*s*c
          a(ip,ip) = w1*c**2+w3*s**2-w
          a(iq,iq) = w1*s**2+w3*c**2+w
          a(ip,iq) = 0.0d0
          a(iq,ip) = 0.0d0
c
          do 260 i=1,n
                   w = u(i,ip)*c-u(i,iq)*s
             u(i,iq) = u(i,ip)*s+u(i,iq)*c
             u(i,ip) = w
  260 continue
c
      go to 210
c
  270 continue
c
      do 700 i=1,n
         xx(i)=a(i,i)
  700 continue
c
      do 830 i=1,n-1
         imin=i
         do 810 j=i+1,n
           if(abs(xx(j)).lt.abs(xx(imin))) imin=j
  810    continue
         xwork   =xx(imin)
         xx(imin)=xx(i)
         xx(i)   =xwork                                                    
         do 820 k=1,n
            uwork   = u(k,imin)
            u(k,imin)=u(k,i)
            u(k,i)  =uwork
  820    continue
  830 continue
c
      do 910 i=1,n
              xmnl(i) = abs(xx(i))
*             print *,'xmnl by Gauss',xmnl(i)
  910 continue
c
      do 920 i=1,n
              if (xx(i).lt.0.d0) then
                  etan(i) = dcmplx(0.d0,1.d0)
              else
                  etan(i) = dcmplx(1.d0,0.d0)
              endif
  920 continue
*     print *,'G:etan',etan
c
      do 930 i=1,n
      do 930 j=1,n
              ogmn(i,j) = u(j,i)
  930 continue
*     write(6,*) 'OGMN(Gauss)'
*     DO 940 I=1,N
*     DO 940 K=1,N
* 940 WRITE(*,*) I,K,OGMN(I,K)
c
c------------------------------------------------------------------
c     check for Gauss
c------------------------------------------------------------------
      do 1030 i = 1 , n
      do 1030 j = 1 , n
         bmtx(i,j) = 0.0d0
         do 1020 k = 1 , n 
            bmtx(i,j) = bmtx(i,j) + a0(i,k)*ogmn(j,k)
 1020    continue
*        print *,'G:bmtx(i,j)',i,j,bmtx(i,j)
 1030 continue
      do 1130 i = 1 , n
      do 1130 j = 1 , n
         cmtx(i,j) = 0.0d0
         do 1120 k = 1 , n 
            cmtx(i,j) = cmtx(i,j) + ogmn(i,k)*bmtx(k,j)
 1120    continue
 1130 continue
c
*     write(6,*)' Normalization check (Gauss)'
*     do 1230 i = 1 , n
*     do 1230 j = 1 , n
*        write(6,*) i,j,cmtx(i,j)
*1230 continue
*-------------------------------------------------------------------
      N  = 4
      N1 = 4
      NE = 4
      NV = 4
      EPS = 1.D-50

      do 2000 j=1,n
      do 2000 i=1,n
         a(i,j)=a0(i,j)
 2000 continue

      CALL EIGRS(A, N, N1, NE, NV, EPS, WORK, LW, E, V, IER)

      WRITE(*,*) 'EIGENVALUES.'
      DO 2100 I = 1 , N
      WRITE(*,*) E(I)
*     WRITE(*,*) 'EIGENVECTORS.'
 2100 CONTINUE
      DO 2150 I = 1, N
         XX(I) = ABS(E(I))
 2150 CONTINUE

      CALL  sorttc(4,xx,is,ir)

*     print *,'is',is
*     print *,'ir',ir
      do 2160 i=1,n
         xmnl(i) = xx(ir(i))
*        print *,'xmnl by Householder',xmnl(i)
 2160 continue
      do 2180 i=1,n
              if (e(ir(i)).lt.0.d0) then
                  etan(i) = dcmplx(0.d0,1.d0)
              else
                  etan(i) = dcmplx(1.d0,0.d0)
              endif
 2180 continue
*     print *,'H:etan',etan
*     DO 2220 I=1,N
*     DO 2220 K=1,N
*2220 WRITE(*,*) I,K,V(I,K)
      DO 2230 I=1,N
      DO 2230 K=1,N
         OGMN2(I,K) = V(K,IR(I))
 2230 CONTINUE
*???
*     DO 2250 I=1,N
*        IF( OGMN2(I,1)*OGMN(I,1) .LT. 0.0D0 ) THEN
*            DO 2240 K=1,N
*               OGMN2(I,K) = -OGMN2(I,K)
*2240        CONTINUE
*        ENDIF
*2250 CONTINUE
*     write(6,*) 'OGMN(Householder)'
*     DO 2940 I=1,N
*     DO 2940 K=1,N
*2940 WRITE(*,*) I,K,OGMN2(I,K),OGMN2(I,K)-OGMN(I,K)
c------------------------------------------------------------------
c     check for Householder
c------------------------------------------------------------------
      do 3030 i = 1 , n
      do 3030 j = 1 , n
         bmtx(i,j) = 0.0d0
         do 3020 k = 1 , n 
            bmtx(i,j) = bmtx(i,j) + a0(i,k)*ogmn2(j,k)
 3020    continue
*        print *,'H:bmtx(i,j)',i,j,bmtx(i,j)
 3030 continue
      do 3130 i = 1 , n
      do 3130 j = 1 , n
         cmtx(i,j) = 0.0d0
         do 3120 k = 1 , n 
            cmtx(i,j) = cmtx(i,j) + ogmn2(i,k)*bmtx(k,j)
 3120    continue
 3130 continue
c
*      write(6,*)' Normalization check (Householder)'
*     do 3230 i = 1 , n
*     do 3230 j = 1 , n
*        write(6,*) i,j,cmtx(i,j)
*3230 continue
*-------------------------------------------------------------------

*     IF( EPS .LT. 1.D0 ) STOP
      do 4000 i=1,n
      do 4000 k=1,n
         ogmn(i,k) = ogmn2(i,k)
 4000 continue

      return
      end
************************************************************************
      SUBROUTINE EIGRS(A, N, N1, NE, NV, EPS, W, LW, E, V, IER)
************************************************************************
*  EIGENVALUES AND EIGENVECTORS FOR A SYMMETRIC MATRIX                 *
*     BY HOUSEHOLDER-BISECTION-INVERSE ITERATION METHOD.               *
*  PARAMETERS                                                          *  
*    (1) A: 2-DIM. ARRAY CONTAINING THE SYMMETRIC MATRIX               * 
*    (2) N: ORDER OF THE MATRIX (A)                                    *
*    (3) N1: ROW SIZE OF THE 2-DIM. ARRAY (A)                          *
*    (4) NE: NUMBER OF NEEDED EIGENVALUES                              *
*    (5) NV: NUMBER OF NEEDED EIGENVECTORS                             *
*    (6) EPS: TOLERANCE FOR CONVERGENCE                                *
*    (7) W: 2-DIM. WORKING ARRAY                                       *
*    (8) LW: 1-DIM. WORKING ARRAY                                      *
*    (9) E: 1-DIM. ARRAY CONTAINING COMPUTED EIGENVALUES               *
*   (10) V: 2-DIM. ARRAY CONTAINING COMPUTED EIGENVECTORS              *
*   (11) IER: ERROR CODE                                               *
*  COPYRIGHT   T. OGUNI   MARCH 25 1990    VERSION 1.1		       *
************************************************************************  
      IMPLICIT REAL*8(A-H,O-Z)
      INTEGER*4 SW
*     DIMENSION A(N1,N), W(N1,7), LW(N), E(N1), V(N1,1)
      DIMENSION A(N1,N), W(N1,7), LW(N), E(N1), V(N1,4)
C
      NEA = IABS(NE)
      NVA = IABS(NV)
      IF (NEA .EQ. 0 .OR. N1 .LT. N .OR. N .LT. NEA .OR. NEA .LT. 
     * NVA .OR. N .LT. 2) THEN
       WRITE(*,*) '(SUBR. EIGRS) INVALID ARGUMENT.',NV,NE,N,N1
       IER = 2
       RETURN
      ENDIF
      IF (EPS .LT. 0.0) EPS = 1.0D-16
      IF (N .EQ. 2) THEN
       W(1,1) = A(2,1)
       T = 0.5D0 * (A(1,1) + A(2,2))
       R = A(1,1) * A(2,2) - A(2,1) * A(2,1)
       D = T * T - R
       Q = DABS(T) + DSQRT(D)
       IF (T .LT. 0.0) Q = - Q
       T = T * DFLOAT(NE)
       IF (T .GE.0.0) THEN
        E(1) = Q
        IF (NEA .EQ. 2) E(2) = R / Q
       ELSE
        E(1) = R / Q
        IF (NEA .EQ. 2) E(2) = Q
       ENDIF
C  REDUCE TO TRIDIAGONAL FORM BY HOUSEHOLDER'S METHOD.
      ELSE
       DO 130 K=1,N-2
        S = 0.0D0
        DO 60 I=K+1,N
   60    S = S + A(I,K) * A(I,K)
        W(K,1) = 0.0D0
       IF (S .NE. 0) THEN
        SR = DSQRT(S)
        A1 = A(K+1,K)
        IF (A1 .LT. 0.0) SR = - SR
        W(K,1) = - SR
        R = 1.0D0 / (S + A1 * SR)
        A(K+1,K) = A1 + SR
        DO 90 I=K+1,N
         S = 0.0D0
         DO 70 J=K+1,I
   70     S = S + A(I,J) * A(J,K)
         IF (I .NE. N) THEN
          DO 80 J=I+1,N
   80      S = S + A(J,I) * A(J,K)
         ENDIF
   90    W(I,1) = S * R
         S = 0.0D0
         DO 100 I=K+1,N
  100     S = S + A(I,K) * W(I,1)
         T = 0.5D0 * S * R
         DO 110 I=K+1,N
  110     W(I,1) = W(I,1) - T * A(I,K)
         DO 120 J=K+1,N
          WJ1 = W(J,1)
          AJK = A(J,K)
          DO 120 I=J,N
  120      A(I,J) = A(I,J) - A(I,K)*WJ1 - W(I,1)*AJK
        ENDIF
  130 CONTINUE
        W(N-1,1) = A(N,N-1)
C  COMPUTE EIGENVALUES BY BISECTION METHOD.
         DO 135 I=1,N
  135     W(I,6) = A(I,I)
      R=DMAX1((DABS(W(1,6))+DABS(W(1,1))),(DABS(W(N-1,1))
     *   +DABS(W(N,6))))
      DO 140 I=2,N-1
       T=DABS(W(I-1,1))+DABS(W(I,6))+DABS(W(I,1))
       IF (T .GT. R) R = T
  140 CONTINUE
      EPS1 = R * 1.0D-16
      EPS2 = R * EPS
      DO 150 I=1,N-1
  150  W(I,2) = W(I,1) * W(I,1)
      IF (NE .LT. 0) R = - R
      F = R
      DO 160 I=1,NEA
  160  E(I) = - R
      DO 240 K=1,NEA
       D = E(K)
  170  T = 0.5D0 * (D + F)
      IF (DABS(D-F).GT.EPS2 .AND. T.NE.D .AND. T.NE.F) THEN
       J = 0
       I = 1
  180 Q = W(I,6) - T
  190 IF (Q .GE. 0.0) J = J + 1
      IF (Q .EQ. 0.0) GO TO 200
      I = I + 1
      IF (I .GT. N) GO TO 210
      Q = W(I,6) - T - W(I-1,2) / Q
      CALL OVERFL(L)
      IF (L .NE. 1) GO TO 190
      J = J + 1
      I = I - 1
  200 I = I + 2
      IF (I .LE. N) GO TO 180
  210 IF (NE .LT. 0) J = N - J
      IF (J .LT. K) THEN
      F = T
      GO TO 170
      ENDIF
      D = T
      M = MIN0(J, NEA)
      DO 230 I=K,M
  230  E(I) = T
      GO TO 170
      ENDIF
  240 E(K) = T
      ENDIF
C  EIGENVECTORS BY INVERSE ITERATION.
        IF (NV .EQ. 0) RETURN
         IF (N .EQ. 2) THEN
          W(1,6) = A(1,1)
          W(2,6) = A(2,2)
         ENDIF
C
        W(N,1) = 0.0D0
        MM = 584287
        DO 410 I=1,NVA
         DO 260 J=1,N
          W(J,2) = W(J,6) - E(I)
          W(J,3) = W(J,1)
  260     V(J,I) = 1.0D0
         SW = 0
C  REDUCE TO TRIANGULAR FORM
         DO 280 J=1,N-1
          IF (DABS(W(J,2)) .GE. DABS(W(J,1))) THEN
           IF (W(J,2) .EQ. 0.0) W(J,2) = 1.0D-30
           W(J,5) = W(J,1) / W(J,2)
           LW(J) = 0
           W(J+1,2) = W(J+1,2) - W(J,5) * W(J,3)
           W(J,4) = 0.0D0
          ELSE
           W(J,5) = W(J,2) / W(J,1)
           LW(J) = 1
           W(J,2) = W(J,1)
           T = W(J,3)
           W(J,3) = W(J+1,2)
           W(J,4) = W(J+1,3)
           W(J+1,2) = T - W(J,5) * W(J,3)
           W(J+1,3) = - W(J,5) * W(J,4)
          ENDIF
  280 CONTINUE
          IF (W(N,2) .EQ. 0.0) W(N,2) = 1.0D-30
C  BEGIN BACK SUBSTITUTION
         IF (I .NE. 1) THEN
          IF (DABS(E(I) - E(I-1)) .LT. EPS1) THEN
C  GENERATE RANDOM NUMBERS
           DO 290 J=1,N
            MM = MM * 48828125
  290       V(J,I) = DFLOAT(MM) * 0.4656613D-9
          ENDIF
        ENDIF
  300 CONTINUE
         T = V(N,I)
         R = V(N-1,I)
  310    V(N,I) = T / W(N,2)
         V(N-1,I) = (R - W(N-1,3) * V(N,I)) / W(N-1,2)
         CALL OVERFL(L)
         IF (L .EQ. 1) THEN
          DO 320 J=1,N-2
  320      V(J,I) = V(J,I) * 1.0D-5
          T = T * 1.0D-5
          R = R * 1.0D-5
          GO TO 310
         ENDIF 
         IF (N .NE. 2) THEN
         K = N - 2
  340    T = V(K,I)
  350    V(K,I) = (T - W(K,3)*V(K+1,I) - W(K,4)*V(K+2,I)) / W(K,2)
        CALL OVERFL(L)
        IF (L .EQ. 1) THEN
         DO 360 J=1,N
  360     V(J,I) = V(J,I) * 1.0D-5
         T = T * 1.0D-5
         GO TO 350
        ENDIF
        K = K - 1
        IF (K .GT. 0) GO TO 340
       ENDIF
        IF (SW .NE. 0) THEN
         SW = 1
         DO 400 J=1,N-1
          IF (LW(J) .NE. 0) THEN
           V(J+1,I) = V(J+1,I) - W(J,5) * V(J,I)
          ELSE
           T = V(J,I)
           V(J,I) = V(J+1,I)
           V(J+1,I) = T - W(J,5) * V(J+1,I)
          ENDIF
  400    CONTINUE
        GO TO 300
       ENDIF
  410 CONTINUE
C  BEGIN BACK TRANSFORMATION
      IF (N .NE. 2) THEN
       DO 415 I=1,N-2
  415   W(I,1) = - W(I,1) * A(I+1,I)
       DO 460 I=1,NVA
        K = N - 2
  420   R = W(K,1)
        IF (R .NE. 0.0) THEN
         R = 1.0D0 / R
         S = 0.0D0
         DO 430 J=K+1,N
  430     S = S + A(J,K) * V(J,I)
         R = R * S
         DO 440 J=K+1,N
  440     V(J,I) = V(J,I) - R * A(J,K)
        ENDIF
        K = K - 1
        IF (K .GE. 1) GO TO 420
  460 CONTINUE
C  NORMALIZE EIGENVECTORS.  MAX ELEMENT IS 1.
      ENDIF
      DO 490 I=1,NVA
       T = DABS(V(1,I))
       K = 1
       DO 480 J=2,N
        R = DABS(V(J,I))
        IF (T .LT. R) THEN
         T = R
         K = J
        ENDIF
  480  CONTINUE
       T = 1.0D0 / V(K,I)
       DO 490 J=1,N
  490   V(J,I) = V(J,I) * T
       IF (NV .LT. 0) RETURN
C  ORTHONORMALIZE AS NORM IS 1.
      DO 550 I=1,NVA
       IF (I .NE. 1) THEN
        IF (DABS(E(I) - E(I-1)) .LT. EPS1) THEN
         DO 510 J=M,I-1
          S = 0.0D0
          DO 500 K=1,N
  500      S = S + V(K,J) * V(K,I)
          DO 510 K=1,N
  510      V(K,I) = V(K,I) - S * V(K,J)
        ELSE
         M = I
        ENDIF
       ENDIF
       S = 0.0D0
       DO 540 J=1,N
  540   S = S + V(J,I) * V(J,I)
       T = 0.0D0
       IF (S .NE. 0.0) T = DSQRT(1.0D0 / S)
       DO 550 J=1,N
  550   V(J,I) = V(J,I) * T
       RETURN
       END
C
       SUBROUTINE OVERFL(L)
       L = 2
       RETURN
       END
C   18/04/87            MEMBER NAME  QSORT2   *.FORT     M  FORTRAN
C   20/06/86 606231856  MEMBER NAME  SORTTC   (FORT)        FORTRAN
      subroutine sorttc(n,x,is,ir)
c
c     sorting and making absolute table and its inverse table
c
c     input :
c            n          : size of the array
c            x(n)       : data which determines the order
c            is(n)      : absolute order
c            ir(n)      : inverse of absolute order
c
c      ex
c          i  x(i)   is(i)        order   ir(order)
c
c          1  3.0      3            1         2
c          2  1.0      1            2         3
c          3  2.0      2            3         1
c
c
c
c
c     created     86/06/21
c                 T. Ishikawa (KEK DD)
c
c
*     integer x(n)
*     real x(n)
      double precision x(n)
      integer is(n),ir(n)
 
      if( x(1) .lt. x(2) ) then
        is(1) = 1
        is(2) = 2
      else
        is(1) = 2
        is(2) = 1
      endif
      do 11 i = 1 , 2
        ir(is(i)) = i
   11 continue
 
      do 26 j = 3 , n
        if( x(j) .lt. x(ir(1)) ) then
          do 21 k = 1 , j-1
            is(k) = is(k) + 1
   21     continue
          is(j) = 1
          do 22 k = 1 , j
            ir(is(k)) = k
   22     continue
        elseif( x(j) .gt. x(ir(j-1)) ) then
          is(j) = j
          ir(j) = j
        else
*         print *,' midium '
          min = 1
          max = j-1
   23     continue
 
          if( max-min .eq. 1 ) then
*           print *,' between min and max '
*           print *,' order array changed'
            do 24 k = max , j-1
              is(ir(k)) = is(ir(k)) + 1
*             print *,'k',k,'is(ir(k))',is(ir(k))
   24       continue
            is(j) = max
            do 25 k = j , max+1, -1
              ir(k) = ir(k-1)
   25       continue
            ir(max) = j
          else
*           print *,' should be iteration '
            m = (max+min)/2
            if( x(j) .lt. x(ir(m)) ) then
              max = m
            else
              min = m
            endif
            goto 23
          endif
        endif
* -- debug --
*     print *
*     do 61 ip = 1 , j
*       write(*,'('' i ='',I3,'' x ='',F6.3,'' is ='',I3,'' ir ='',I3)')
*    &  ip, x(ip), is(ip), ir(ip)
*  61 continue
* -- debug --
 
   26 continue
      return
      end
